// Generated by CoffeeScript 1.7.1
(function() {
  var SocketIORemoteEndpoint;

  SocketIORemoteEndpoint = (function() {
    function SocketIORemoteEndpoint() {}

    SocketIORemoteEndpoint.prototype.initialize = function(options, callback) {
      if (options == null) {
        options = {};
      }
      if (callback == null) {
        callback = function() {};
      }
      if (options.ioInstance) {
        this._io = options.ioInstance;
      } else {
        this._io = require('socket.io')();
        this._io.listen(3000);
      }
      this._io.sockets.on('connection', (function(_this) {
        return function(socket) {
          return socket.on('RPC_Request', function(RPC_Request) {
            return _this._handleRPCRequest(RPC_Request, function(err, response) {
              var rpcId;
              rpcId = RPC_Request.rpcId;
              return socket.emit('RPC_Response', {
                rpcId: rpcId,
                err: err,
                data: response
              });
            });
          });
        };
      })(this));
      return callback();
    };

    SocketIORemoteEndpoint.prototype.close = function() {
      return this._io.engine.close();
    };

    SocketIORemoteEndpoint.prototype.setRPCHandler = function(_handleRPCRequest) {
      this._handleRPCRequest = _handleRPCRequest;
    };

    SocketIORemoteEndpoint.prototype.publish = function(channel, eventName, payload) {
      return this._io.to(channel).emit(eventName, payload);
    };

    return SocketIORemoteEndpoint;

  })();

  module.exports = new SocketIORemoteEndpoint;

}).call(this);
